#!/usr/bin/env python
#
# This file is part of Hablame!
# Author(s): Gretchen Jolie Peavy, Girlstart
# Copyright 2008
#
# Source code is derived from Girlstart's Project IT Girl Game Templates:
# http://itgirl.dreamhosters.com/itgirlgames/, http://www.girlstart.org/itgirl
# See the credits file for image sources.
#
# Hablame! is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Hablame! is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Hablame!.  If not, see <http://www.gnu.org/licenses/>.

import pygame, ActivityBase
from helpers import *

class Activity1(ActivityBase.ActivityBase):
	def __init__(self,topleft,background_image,main_image_file,completed_image_file):
		ActivityBase.ActivityBase.__init__(self,topleft,background_image,main_image_file,completed_image_file)
	
	
	def askQuestion(self, questionText, answer1, answer1rect, answer2, answer2rect, answer3, answer3rect, correctAnswerrect):
																																																																																																																																																																					# questionText is the string of the question
		# answer1, answer2 and answer3 are the possible answers for the user to choose
		# answer1rect, answer2rect and answer3rect are the Rects that describe where the images for
		# the answers need to be drawn.
		# correctAnswer is the correct answer
		
		# Set up the font for our question.  Redraw the background first to clear the screen
		self.screen.blit(self.background, (0, 0))
		font = pygame.font.Font(None, 30)
		text = font.render(questionText, 1, (255, 255, 255))
		textrect = text.get_rect()
		textrect.centerx, textrect.centery = self.area.centerx,75
		self.screen.blit(text, textrect)
		
		# Draw our answers to the screen
		self.screen.blit(answer1, answer1rect)
		self.screen.blit(answer2, answer2rect)
		self.screen.blit(answer3, 
		)
		
		pygame.display.flip()
		
		# Now let's loop waiting for the user's answer
		answered = False
		while not answered:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == pygame.MOUSEBUTTONDOWN:
						if answer1rect.collidepoint(event.pos):
							# If we're here, then the user has clicked on one of the answers.
							answered = True
							if answer1rect == correctAnswerrect:
								# User answered correctly, let them know
								correct = True
							else:
								correct = False
						elif answer2rect.collidepoint(event.pos):
							answered = True
							if answer2rect == correctAnswerrect:
								correct = True
							else:
								correct = False
						elif answer3rect.collidepoint(event.pos):
							answered = True
							if answer3rect == correctAnswerrect:
								correct = True
							else:
								correct = False

		# The user has answered.  Display the results of their answer.  Remember, we need to redraw the background
		# in order to get rid of the previous stuff drawn to the screen.
		if correct:
			text = font.render("Correct!  Press any key to continue", 1, (255,255,255))
		else:
			text = font.render("Sorry, that's not correct.  Press any key to continue", 1, (255,255,255))
		
		self.screen.blit(self.background, (0, 0))
		textrect = text.get_rect()
		textrect.centerx, textrect.centery = self.area.centerx,75
		self.screen.blit(text, textrect)
		
		pygame.display.flip()
		
		# Now, wait for the user to click a key to continue:
		answered = False
		while not answered:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == pygame.KEYDOWN:
					answered = True				
		
		return correct


	
		ActivityBase.ActivityBase.__init__(self,topleft,background_image,main_image_file,completed_image_file)
	def askQuestion(self, questionText, answer1, answer1rect, answer2, answer2rect, answer3, answer3rect, correctAnswerrect):
		# questionText is the string of the question
		# answer1, answer2 and answer3 are the possible answers for the user to choose
		# answer1rect, answer2rect and answer3rect are the Rects that describe where the images for
		# the answers need to be drawn.
		# correctAnswer is the correct answer
		
		# Set up the font for our question.  Redraw the background first to clear the screen
		self.screen.blit(self.background, (0, 0))
		font = pygame.font.Font(None, 30)
		text = font.render(questionText, 1, (255, 255, 255))
		textrect = text.get_rect()
		textrect.centerx, textrect.centery = self.area.centerx,75
		self.screen.blit(text, textrect)
		
		# Draw our answers to the screen
		self.screen.blit(answer1, answer1rect)
		self.screen.blit(answer2, answer2rect)
		self.screen.blit(answer3, answer3rect)
		
		pygame.display.flip()
		
		# Now let's loop waiting for the user's answer
		answered = False
		while not answered:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == pygame.MOUSEBUTTONDOWN:
						if answer1rect.collidepoint(event.pos):
							# If we're here, then the user has clicked on one of the answers.
							answered = True
							if answer1rect == correctAnswerrect:
								# User answered correctly, let them know
								correct = True
							else:
								correct = False
						elif answer2rect.collidepoint(event.pos):
							answered = True
							if answer2rect == correctAnswerrect:
								correct = True
							else:
								correct = False
						elif answer3rect.collidepoint(event.pos):
							answered = True
							if answer3rect == correctAnswerrect:
								correct = True
							else:
								correct = False

		# The user has answered.  Display the results of their answer.  Remember, we need to redraw the background
		# in order to get rid of the previous stuff drawn to the screen.
		if correct:
			text = font.render("Correct!  Press any key to continue", 1, (255,255,255))
		else:
			text = font.render("Sorry, that's not correct.  Press any key to continue", 1, (255,255,255))
		
		self.screen.blit(self.background, (0, 0))
		textrect = text.get_rect()
		textrect.centerx, textrect.centery = self.area.centerx,75
		self.screen.blit(text, textrect)
		
		pygame.display.flip()
		
		# Now, wait for the user to click a key to continue:
		answered = False
		while not answered:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == pygame.KEYDOWN:
					answered = True				
		
		return correct

	def play(self):
		# Load all of our images for our question:
		answer1, answer1rect = load_image("backpack smaller.png")
		answer2, answer2rect = load_image("pencil smaller.png")
		answer3, answer3rect = load_image("notepad.gif")
		answer4, answer4rect = load_image("pen.png")
		answer5, answer5rect = load_image("pencil smaller.png")
		answer6, answer6rect = load_image("notebook.bmp")
		answer7, answer7rect = load_image("paper.bmp")
		answer8, answer8rect = load_image("pencil smaller.png")
		answer9, answer9rect = load_image("notebook.bmp")
		answer1rect.center = 100,400
		answer2rect.center = 400,400
		answer3rect.center = 700,400
		answer4rect.center = 100,400
		answer5rect.center = 400,400
		answer6rect.center = 700,400
		answer7rect.center = 100,400
		answer8rect.center = 400,400
		answer9rect.center = 700,400

		while not self.activity_completed:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
					# Ask our question until they get it right
			if self.askQuestion("You left your mochila at school. Which is your mochila?", answer1, answer1rect, answer2, answer2rect, answer3, answer3rect, answer1rect) and self.askQuestion("Your teacher wants you to use a lapiz. Which is a lapiz?", answer4, answer4rect, answer5, answer5rect, answer6, answer6rect, answer5rect) and self.askQuestion("You need your cuaderno for class. Which is a cuaderno? ", answer7, answer7rect, answer8, answer8rect, answer9, answer9rect, answer9rect):
				self.activity_completed = True

				

		self.image = self.completed_image
		self.completed_image_rect.topleft = self.rect.topleft
		self.rect = self.completed_image_rect

class Activity2(ActivityBase.ActivityBase):
	def __init__(self,topleft,background_image,main_image_file,completed_image_file):
		ActivityBase.ActivityBase.__init__(self,topleft,background_image,main_image_file,completed_image_file)
	def askQuestion(self, questionText, answer1, answer1rect, answer2, answer2rect, answer3, answer3rect, correctAnswerrect):
		# questionText is the string of the question
		# answer1, answer2 and answer3 are the possible answers for the user to choose
		# answer1rect, answer2rect and answer3rect are the Rects that describe where the images for
		# the answers need to be drawn.
		# correctAnswer is the correct answer
		
		# Set up the font for our question.  Redraw the background first to clear the screen
		self.screen.blit(self.background, (0, 0))
		font = pygame.font.Font(None, 30)
		text = font.render(questionText, 1, (255, 255, 255))
		textrect = text.get_rect()
		textrect.centerx, textrect.centery = self.area.centerx,75
		self.screen.blit(text, textrect)
		
		# Draw our answers to the screen
		self.screen.blit(answer1, answer1rect)
		self.screen.blit(answer2, answer2rect)
		self.screen.blit(answer3, answer3rect)
		
		pygame.display.flip()
		
		# Now let's loop waiting for the user's answer
		answered = False
		while not answered:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == pygame.MOUSEBUTTONDOWN:
						if answer1rect.collidepoint(event.pos):
							# If we're here, then the user has clicked on one of the answers.
							answered = True
							if answer1rect == correctAnswerrect:
								# User answered correctly, let them know
								correct = True
							else:
								correct = False
						elif answer2rect.collidepoint(event.pos):
							answered = True
							if answer2rect == correctAnswerrect:
								correct = True
							else:
								correct = False
						elif answer3rect.collidepoint(event.pos):
							answered = True
							if answer3rect == correctAnswerrect:
								correct = True
							else:
								correct = False

		# The user has answered.  Display the results of their answer.  Remember, we need to redraw the background
		# in order to get rid of the previous stuff drawn to the screen.
		if correct:
			text = font.render("Correct!  Press any key to continue", 1, (255,255,255))
		else:
			text = font.render("Sorry, that's not correct.  Press any key to continue", 1, (255,255,255))
		
		self.screen.blit(self.background, (0, 0))
		textrect = text.get_rect()
		textrect.centerx, textrect.centery = self.area.centerx,75
		self.screen.blit(text, textrect)
		
		pygame.display.flip()
		
		# Now, wait for the user to click a key to continue:
		answered = False
		while not answered:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == pygame.KEYDOWN:
					answered = True				
		
		return correct

	def play(self):
		# Load all of our images for our question:
		answer1, answer1rect = load_image("apple.png")
		answer2, answer2rect = load_image("orange.png")
		answer3, answer3rect = load_image("bananas1.gif")
		answer4, answer4rect = load_image("chips.bmp")
		answer5, answer5rect = load_image("bread3.jpg")
		answer6, answer6rect = load_image("cookies.bmp")
		answer7, answer7rect = load_image("juice.bmp")
		answer8, answer8rect = load_image("waterglass2.jpg")
		answer9, answer9rect = load_image("milk-1.gif")
		answer1rect.center = 100,400
		answer2rect.center = 400,400
		answer3rect.center = 700,400
		answer4rect.center = 100,400
		answer5rect.center = 400,400
		answer6rect.center = 700,400
		answer7rect.center = 100,400
		answer8rect.center = 400,400
		answer9rect.center = 700,400

		while not self.activity_completed:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				# Ask our question until they get it right
			if self.askQuestion("Your mom needs platanos. What are platanos?", answer1, answer1rect, answer2, answer2rect, answer3, answer3rect, answer3rect) and self.askQuestion("Your mom needs pan. What is pan?", answer4, answer4rect, answer5, answer5rect, answer6, answer6rect, answer5rect) and self.askQuestion("Your mom needs leche. What is leche?", answer7, answer7rect, answer8, answer8rect, answer9, answer9rect, answer9rect):
				self.activity_completed = True

		self.image = self.completed_image
		self.completed_image_rect.topleft = self.rect.topleft
		self.rect = self.completed_image_rect

class Activity3(ActivityBase.ActivityBase):
	def __init__(self,topleft,background_image,main_image_file,completed_image_file):
		ActivityBase.ActivityBase.__init__(self,topleft,background_image,main_image_file,completed_image_file)
	def askQuestion(self, questionText, answer1, answer1rect, answer2, answer2rect, answer3, answer3rect, correctAnswerrect):
		# questionText is the string of the question
		# answer1, answer2 and answer3 are the possible answers for the user to choose
		# answer1rect, answer2rect and answer3rect are the Rects that describe where the images for
		# the answers need to be drawn.
		# correctAnswer is the correct answer
		
		# Set up the font for our question.  Redraw the background first to clear the screen
		self.screen.blit(self.background, (0, 0))
		font = pygame.font.Font(None, 30)
		text = font.render(questionText, 1, (255, 255, 255))
		textrect = text.get_rect()
		textrect.centerx, textrect.centery = self.area.centerx,75
		self.screen.blit(text, textrect)
		
		# Draw our answers to the screen
		self.screen.blit(answer1, answer1rect)
		self.screen.blit(answer2, answer2rect)
		self.screen.blit(answer3, answer3rect)
		
		pygame.display.flip()
		
		# Now let's loop waiting for the user's answer
		answered = False
		while not answered:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == pygame.MOUSEBUTTONDOWN:
						if answer1rect.collidepoint(event.pos):
							# If we're here, then the user has clicked on one of the answers.
							answered = True
							if answer1rect == correctAnswerrect:
								# User answered correctly, let them know
								correct = True
							else:
								correct = False
						elif answer2rect.collidepoint(event.pos):
							answered = True
							if answer2rect == correctAnswerrect:
								correct = True
							else:
								correct = False
						elif answer3rect.collidepoint(event.pos):
							answered = True
							if answer3rect == correctAnswerrect:
								correct = True
							else:
								correct = False

		# The user has answered.  Display the results of their answer.  Remember, we need to redraw the background
		# in order to get rid of the previous stuff drawn to the screen.
		if correct:
			text = font.render("Correct!  Press any key to continue", 1, (255,255,255))
		else:
			text = font.render("Sorry, that's not correct.  Press any key to continue", 1, (255,255,255))
		
		self.screen.blit(self.background, (0, 0))
		textrect = text.get_rect()
		textrect.centerx, textrect.centery = self.area.centerx,75
		self.screen.blit(text, textrect)
		
		pygame.display.flip()
		
		# Now, wait for the user to click a key to continue:
		answered = False
		while not answered:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == pygame.KEYDOWN:
					answered = True				
		
		return correct

	def play(self):
		# Load all of our images for our question:
		answer1, answer1rect = load_image("shirt.bmp")
		answer2, answer2rect = load_image("pants3.gif")
		answer3, answer3rect = load_image("jacket.bmp")
		answer4, answer4rect = load_image("pants.bmp")
		answer5, answer5rect = load_image("shirt.bmp")
		answer6, answer6rect = load_image("jacket.bmp")
		answer7, answer7rect = load_image("shoes.bmp")
		answer8, answer8rect = load_image("pants.bmp")
		answer9, answer9rect = load_image("jacket.bmp")
		answer1rect.center = 100,400
		answer2rect.center = 400,400
		answer3rect.center = 700,400
		answer4rect.center = 100,400
		answer5rect.center = 400,400
		answer6rect.center = 700,400
		answer7rect.center = 100,400
		answer8rect.center = 400,400
		answer9rect.center = 700,400

		while not self.activity_completed:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
					# Ask our question until they get it right
			if self.askQuestion("You need a new camisa. Which is it a camisa?", answer1, answer1rect, answer2, answer2rect, answer3, answer3rect, answer1rect) and self.askQuestion("You need a chaqueta for this winter. Which is a chaqueta?", answer4, answer4rect, answer5, answer5rect, answer6, answer6rect, answer6rect) and self.askQuestion("Your little brother needs zapatos. Which are zapatos?", answer7, answer7rect, answer8, answer8rect, answer9, answer9rect, answer7rect):
				self.activity_completed = True


				

		self.image = self.completed_image
		self.completed_image_rect.topleft = self.rect.topleft
		self.rect = self.completed_image_rect

class Activity4(ActivityBase.ActivityBase):
	def __init__(self,topleft,background_image,main_image_file,completed_image_file):
		ActivityBase.ActivityBase.__init__(self,topleft,background_image,main_image_file,completed_image_file)
	def askQuestion(self, questionText, answer1, answer1rect, answer2, answer2rect, answer3, answer3rect, correctAnswerrect):
		# questionText is the string of the question
		# answer1, answer2 and answer3 are the possible answers for the user to choose
		# answer1rect, answer2rect and answer3rect are the Rects that describe where the images for
		# the answers need to be drawn.
		# correctAnswer is the correct answer
		
		# Set up the font for our question.  Redraw the background first to clear the screen
		self.screen.blit(self.background, (0, 0))
		font = pygame.font.Font(None, 30)
		text = font.render(questionText, 1, (255, 255, 255))
		textrect = text.get_rect()
		textrect.centerx, textrect.centery = self.area.centerx,75
		self.screen.blit(text, textrect)
		
		# Draw our answers to the screen
		self.screen.blit(answer1, answer1rect)
		self.screen.blit(answer2, answer2rect)
		self.screen.blit(answer3, answer3rect)
		
		pygame.display.flip()
		
		# Now let's loop waiting for the user's answer
		answered = False
		while not answered:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == pygame.MOUSEBUTTONDOWN:
						if answer1rect.collidepoint(event.pos):
							# If we're here, then the user has clicked on one of the answers.
							answered = True
							if answer1rect == correctAnswerrect:
								# User answered correctly, let them know
								correct = True
							else:
								correct = False
						elif answer2rect.collidepoint(event.pos):
							answered = True
							if answer2rect == correctAnswerrect:
								correct = True
							else:
								correct = False
						elif answer3rect.collidepoint(event.pos):
							answered = True
							if answer3rect == correctAnswerrect:
								correct = True
							else:
								correct = False

		# The user has answered.  Display the results of their answer.  Remember, we need to redraw the background
		# in order to get rid of the previous stuff drawn to the screen.
		if correct:
			text = font.render("Correct!  Press any key to continue", 1, (255,255,255))
		else:
			text = font.render("Sorry, that's not correct.  Press any key to continue", 1, (255,255,255))
		
		self.screen.blit(self.background, (0, 0))
		textrect = text.get_rect()
		textrect.centerx, textrect.centery = self.area.centerx,75
		self.screen.blit(text, textrect)
		
		pygame.display.flip()
		
		# Now, wait for the user to click a key to continue:
		answered = False
		while not answered:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == pygame.KEYDOWN:
					answered = True				
		
		return correct

	def play(self):
		# Load all of our images for our question:
		answer1, answer1rect = load_image("table.bmp")
		answer2, answer2rect = load_image("couch.bmp")
		answer3, answer3rect = load_image("chair.bmp")
		answer4, answer4rect = load_image("desk.bmp")
		answer5, answer5rect = load_image("table.bmp")
		answer6, answer6rect = load_image("bed.bmp")
		answer7, answer7rect = load_image("desk.bmp")
		answer8, answer8rect = load_image("chair.bmp")
		answer9, answer9rect = load_image("table.bmp")
		answer1rect.center = 100,400
		answer2rect.center = 400,400
		answer3rect.center = 700,400
		answer4rect.center = 100,400
		answer5rect.center = 400,400
		answer6rect.center = 700,400
		answer7rect.center = 100,400
		answer8rect.center = 400,400
		answer9rect.center = 700,400

		while not self.activity_completed:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				# Ask our question until they get it right
			if self.askQuestion("Your mom wants to move the mesa. What is a mesa?", answer1, answer1rect, answer2, answer2rect, answer3, answer3rect, answer1rect) and self.askQuestion("Your mom wants you to clear off the cama. Which is a cama? ", answer4, answer4rect, answer5, answer5rect, answer6, answer6rect, answer6rect) and self.askQuestion("Your parents tell you to go do your homework in your silla. What is a silla?", answer7, answer7rect, answer8, answer8rect, answer9, answer9rect, answer8rect):
				self.activity_completed = True


		self.image = self.completed_image
		self.completed_image_rect.topleft = self.rect.topleft
		self.rect = self.completed_image_rect
